aboutsummaryrefslogtreecommitdiff
path: root/git-pull.sh
diff options
context:
space:
mode:
authorJeff King <peff@peff.net>2007-01-15 17:25:33 -0500
committerJunio C Hamano <junkio@cox.net>2007-01-15 15:37:22 -0800
commita74b1706c89c5e966c64316575e0b33dd21b8128 (patch)
tree715fa28328a866548a5101e87537aa94a1708e61 /git-pull.sh
parenta0f4280f9e5decd384fe5cc9e30414b901aeb478 (diff)
downloadgit-a74b1706c89c5e966c64316575e0b33dd21b8128.tar.gz
git-a74b1706c89c5e966c64316575e0b33dd21b8128.tar.xz
git-pull: disallow implicit merging to detached HEAD
Instead, we complain to the user and suggest that they explicitly specify the remote and branch. We depend on the exit status of git-symbolic-ref, so let's go ahead and document that. Signed-off-by: Jeff King <peff@peff.net> Signed-off-by: Junio C Hamano <junkio@cox.net>
Diffstat (limited to 'git-pull.sh')
-rwxr-xr-xgit-pull.sh13
1 files changed, 11 insertions, 2 deletions
diff --git a/git-pull.sh b/git-pull.sh
index 959261757..a3665d775 100755
--- a/git-pull.sh
+++ b/git-pull.sh
@@ -83,8 +83,17 @@ merge_head=$(sed -e '/ not-for-merge /d' \
case "$merge_head" in
'')
- curr_branch=$(git-symbolic-ref HEAD | \
- sed -e 's|^refs/heads/||')
+ curr_branch=$(git-symbolic-ref -q HEAD)
+ case $? in
+ 0) ;;
+ 1) echo >&2 "You are not currently on a branch; you must explicitly"
+ echo >&2 "specify which branch you wish to merge:"
+ echo >&2 " git pull <remote> <branch>"
+ exit 1;;
+ *) exit $?;;
+ esac
+ curr_branch=${curr_branch#refs/heads/}
+
echo >&2 "Warning: No merge candidate found because value of config option
\"branch.${curr_branch}.merge\" does not match any remote branch fetched."
echo >&2 "No changes."